# GenerateProgressWindow Struct Reference

Inheritance diagram for GenerateProgressWindow:

## Public Member Functions
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.

## Detailed Description

Definition at line 1158 of file genworld_gui.cpp.

## Member Function Documentation

virtual void GenerateProgressWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1205 of file genworld_gui.cpp.

References DrawFrameRect(), DrawString(), FONT_HEIGHT_NORMAL, FR_BORDERONLY, SA_CENTER, SetDParam(), and WD_PAR_VSEP_NORMAL.

virtual void GenerateProgressWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1165 of file genworld_gui.cpp.

References SetMouseCursor(), ShowQuery(), SPR_CURSOR_MOUSE, and CursorVars::sprite.

virtual void GenerateProgressWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1180 of file genworld_gui.cpp.

References Window::DrawWidgets().

virtual void GenerateProgressWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 1185 of file genworld_gui.cpp.

References FONT_HEIGHT_NORMAL, GetStringBoundingBox(), max(), SetDParam(), WD_PAR_VSEP_NORMAL, and Window::width.

The documentation for this struct was generated from the following file:

- src/genworld_gui.cpp